image: docker:latest
services:
  - name: docker:dind
    alias: docker

stages:
  - build
  - release
  - deploy

variables:
  TEST_IMAGE: dok-valasztas:$CI_COMMIT_REF_NAME
  RELEASE_IMAGE: jelszoco/dok-valasztas-backend:latest

before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY

build:
  stage: build
  script:
    - docker build --pull -t $CI_REGISTRY_IMAGE/$TEST_IMAGE .
    - docker push $CI_REGISTRY_IMAGE/$TEST_IMAGE

release:
  stage: release
  variables:
    GIT_STRATEGY: none
  script:
    - docker login -u $DOCKERHUB_USERNAME -p $DOCKERHUB_PASSWORD
    - docker pull $CI_REGISTRY_IMAGE/$TEST_IMAGE
    - docker tag $CI_REGISTRY_IMAGE/$TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
  only:
    - master

deploy-dev:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  script:
    - docker run caprover/cli-caprover:v2.1.1 caprover deploy --caproverUrl $CAPROVER_URL --caproverPassword $CAPROVER_PASSWORD --caproverApp $CAPROVER_APP-dev --imageName $CI_REGISTRY_IMAGE/$TEST_IMAGE
  only:
    - dev

deploy:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  script:
    - docker run caprover/cli-caprover:v2.1.1 caprover deploy --caproverUrl $CAPROVER_URL --caproverPassword $CAPROVER_PASSWORD --caproverApp $CAPROVER_APP --imageName $RELEASE_IMAGE
  only:
    - master